/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var app = {
  // Application Constructor
  $: jQuery,
  MENU_ID: '#menu',
  MENU_SELECTOR: '.dismiss',
  PORTAL_ID: '#portal',
  VERSION_ID: '#version',
  FAQ_ID: '#faq',
  IFRAME_ID: '#frame',
  PAGE_SELECTOR: '.page',
  PC_FORUMS_LINK: 'http://goo.gl/OxFYvG',
  XBOX_FORUMS_LINK: 'http://goo.gl/lg1an3',
  WIKI_LINK: 'http://goo.gl/aifmJM',
  NEWS_LINK: 'http://goo.gl/JEzanF',
  XBOX_REDDIT_LINK: 'https://goo.gl/ezSbzi',
  initialize: function () {
    app.bindEvents();
    $(app.MENU_ID).show();
    $(app.PORTAL_ID).hide();
    $(app.VERSION_ID).hide();
    $(app.MENU_SELECTOR).click(function(){app.openPage(app.MENU_ID);});
    $('#open-menu').click(function(){app.openPage(app.MENU_ID);});
    $('#open-portal').click(function(){
      app.openPage(app.PORTAL_ID);
      $(app.IFRAME_ID)
        .width('100%')
        .height('100%');
    });
    $('#open-version').click(function(){app.openPage(app.VERSION_ID);});
    $('#open-faq').click(function(){app.openPage(app.FAQ_ID);});
    $('#open-xbox-reddit').click(function(){app.openLink(app.XBOX_REDDIT_LINK);});
    $('#open-news').click(function(){app.openLink(app.NEWS_LINK);});
    $('#open-pc-forums').click(function(){app.openLink(app.PC_FORUMS_LINK);});
    $('#open-xbox-forums').click(function(){app.openLink(app.XBOX_FORUMS_LINK);});
    $('#open-wiki').click(function(){app.openLink(app.WIKI_LINK);});
  },
  // Bind Event Listeners
  //
  // Bind any events that are required on startup. Common events are:
  // 'load', 'deviceready', 'offline', and 'online'.
  bindEvents: function () {
    document.addEventListener('deviceready', app.onDeviceReady, false);
  },
  // deviceready Event Handler
  //
  // The scope of 'this' is the event. In order to call the 'receivedEvent'
  // function, we must explicitly call 'app.receivedEvent(...);'
  onDeviceReady: function () {
    app.receivedEvent('deviceready');
  },
  // Update DOM on a Received Event
  receivedEvent: function (id) {
    /*var parentElement = document.getElementById(id);
     var listeningElement = parentElement.querySelector('.listening');
     var receivedElement = parentElement.querySelector('.received');

     listeningElement.setAttribute('style', 'display:none;');
     receivedElement.setAttribute('style', 'display:block;');

     console.log('Received Event: ' + id);*/
  },
  openPage: function(elementId){
    app.closeAllPages();
    $(elementId).show();
  },
  closeAllPages: function(){
    $(app.PAGE_SELECTOR).each(function(){
      $(this).hide();
    });
  },
  openLink: function(url){
    window.open(url, '_system', 'location=yes');
  },
  openPortal: function () {
    console.log(app.PORTAL_ID);
    $(app.PORTAL_ID)
      .width(app.IFRAME_WIDTH)
      .height(app.IFRAME_HEIGHT)
      .show();
    $(app.IFRAME_ID)
      .width($(app.PORTAL_ID).width())
      .height($(app.PORTAL_ID).height());
  },
  closePortal: function () {
    $(app.PORTAL_ID).hide();
  },
  openVersion: function () {
    $(app.VERSION_ID)
      .width(app.IFRAME_WIDTH)
      .height(app.IFRAME_HEIGHT)
      .show();
  },
  openFAQ: function () {
    $(app.FAQ_ID)
      .width(app.IFRAME_WIDTH)
      .height(app.IFRAME_HEIGHT)
      .show();
  },
  closeVersion: function () {
    $(app.VERSION_ID).hide();
  },
  closeFAQ: function () {
    $(app.FAQ_ID).hide();
  },
  openWiki: function () {
    window.open('http://goo.gl/aifmJM', '_system', 'location=yes');
  },
  openNews: function () {
    window.open('http://goo.gl/JEzanF', '_system', 'location=yes');
  },
  openPCForums: function () {
    window.open('http://goo.gl/OxFYvG', '_system', 'location=yes');
  },
  openXBOXForums: function () {
    window.open('http://goo.gl/lg1an3', '_system', 'location=yes');
  },
  openXBOXReddit: function () {
    window.open('https://goo.gl/ezSbzi', '_system', 'location=yes');
  }
};
